#include "http.h"
#include "http_loop.h"

http_loop_gctx *http_loop_gctx_init() {
  http_loop_gctx *gctx = calloc(sizeof(http_loop_gctx), 1);

  return gctx;
}

http_loop_ctx *http_loop_ctx_init(http_loop_gctx *g) {
  http_loop_ctx *ctx = calloc(sizeof(http_loop_ctx), 1);
  ctx->g = g;

  return ctx;
}

void http_loop_ctx_free(http_loop_ctx *ctx) {
  http_loop_ctx_reset(ctx);

  free(ctx);
}

void http_loop_ctx_reset(http_loop_ctx *ctx) {
  ctx->route = NULL;
  ctx->current_step = 0;

  if (ctx->res.head != NULL) {
    free((void *)ctx->res.head);
    ctx->res.head = NULL;
  }

  if (ctx->res.owns_body && ctx->res.body != NULL) {
    free((void *)ctx->res.body);
  }

  ctx->res.body = NULL;

  ctx->res.head_len = 0;
  ctx->res.head_written = 0;
  ctx->res.body_len = 0;
  ctx->res.body_written = 0;
  ctx->res.owns_body = false;
}
